config/routes.rb
Rails.application.routes.draw do
  devise_for :admin_users, ActiveAdmin::Devise.config
  ActiveAdmin.routes(self)
  devise_for :users
  resources :users
  resources :desks
  resources :bookings
  root to: "bookings#index"

end

app/models/admin_user.rb
class AdminUser < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, 
         :recoverable, :rememberable, :validatable
end

app/models/booking.rb
class Booking < ActiveRecord::Base
  belongs_to :user
  belongs_to :desk

  validates :start_at, :end_at, overlap: { scope: 'desk_id', message_content: 'Conflict!!!' }
end

app/models/desk.rb
class Desk < ActiveRecord::Base
	has_many :bookings
end

app/models/user.rb
class User < ActiveRecord::Base
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable
	has_many :bookings
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
  # Prevent CSRF attacks by raising an exception.
  # For APIs, you may want to use :null_session instead.
  protect_from_forgery with: :exception

  before_action :configure_permitted_parameters, if: :devise_controller?

  protected

  def configure_permitted_parameters
    added_attrs = [:name, :email, :password, :password_confirmation, :remember_me]
    devise_parameter_sanitizer.permit :sign_up, keys: added_attrs
    devise_parameter_sanitizer.permit :account_update, keys: added_attrs
  end
end

app/controllers/bookings_controller.rb
class BookingsController < ApplicationController
  before_action :set_booking, only: [:show, :edit, :update, :destroy]
  # GET /bookings
  # GET /bookings.json
  def index
    @bookings = Booking.all
  end

  # GET /bookings/1
  # GET /bookings/1.json
  def show
  end

  # GET /bookings/new
  def new
    @booking = Booking.new
  end

  # GET /bookings/1/edit
  def edit
  end

  # POST /bookings
  # POST /bookings.json
  def create
    @booking = Booking.new(booking_params)

    respond_to do |format|
      if @booking.save
        format.html { redirect_to @booking, notice: 'Booking was successfully created.' }
        format.json { render :show, status: :created, location: @booking }
      else
        format.html { render :new }
        format.json { render json: @booking.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /bookings/1
  # PATCH/PUT /bookings/1.json
  def update
    respond_to do |format|
      if @booking.update(booking_params)
        format.html { redirect_to @booking, notice: 'Booking was successfully updated.' }
        format.json { render :show, status: :ok, location: @booking }
      else
        format.html { render :edit }
        format.json { render json: @booking.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /bookings/1
  # DELETE /bookings/1.json
  def destroy
    @booking.destroy
    respond_to do |format|
      format.html { redirect_to bookings_url, notice: 'Booking was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_booking
      @booking = Booking.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def booking_params
      params.require(:booking).permit(:start_at, :end_at, :user_id, :desk_id)
    end
end

app/controllers/desks_controller.rb
class DesksController < ApplicationController
  before_action :set_desk, only: [:show, :edit, :update, :destroy]

  # GET /desks
  # GET /desks.json
  def index
    @desks = Desk.all
  end

  # GET /desks/1
  # GET /desks/1.json
  def show
  end

  # GET /desks/new
  def new
    @desk = Desk.new
  end

  # GET /desks/1/edit
  def edit
  end

  # POST /desks
  # POST /desks.json
  def create
    @desk = Desk.new(desk_params)

    respond_to do |format|
      if @desk.save
        format.html { redirect_to @desk, notice: 'Desk was successfully created.' }
        format.json { render :show, status: :created, location: @desk }
      else
        format.html { render :new }
        format.json { render json: @desk.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /desks/1
  # PATCH/PUT /desks/1.json
  def update
    respond_to do |format|
      if @desk.update(desk_params)
        format.html { redirect_to @desk, notice: 'Desk was successfully updated.' }
        format.json { render :show, status: :ok, location: @desk }
      else
        format.html { render :edit }
        format.json { render json: @desk.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /desks/1
  # DELETE /desks/1.json
  def destroy
    @desk.destroy
    respond_to do |format|
      format.html { redirect_to desks_url, notice: 'Desk was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_desk
      @desk = Desk.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def desk_params
      params.require(:desk).permit(:name)
    end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
  before_action :set_user, only: [:show, :edit, :update, :destroy]

  # GET /users
  # GET /users.json
  def index
    @users = User.all
  end

  # GET /users/1
  # GET /users/1.json
  def show
  end

  # GET /users/new
  def new
    @user = User.new
  end

  # GET /users/1/edit
  def edit
  end

  # POST /users
  # POST /users.json
  def create
    @user = User.new(user_params)

    respond_to do |format|
      if @user.save
        format.html { redirect_to @user, notice: 'User was successfully created.' }
        format.json { render :show, status: :created, location: @user }
      else
        format.html { render :new }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /users/1
  # PATCH/PUT /users/1.json
  def update
    respond_to do |format|
      if @user.update(user_params)
        format.html { redirect_to @user, notice: 'User was successfully updated.' }
        format.json { render :show, status: :ok, location: @user }
      else
        format.html { render :edit }
        format.json { render json: @user.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /users/1
  # DELETE /users/1.json
  def destroy
    @user.destroy
    respond_to do |format|
      format.html { redirect_to users_url, notice: 'User was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_user
      @user = User.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def user_params
      params.require(:user).permit(:name)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/bookings_helper.rb
module BookingsHelper
end

app/helpers/desks_helper.rb
module DesksHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/bookings/_form.html.erb
<%= form_for(@booking) do |f| %>
  <% if @booking.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@booking.errors.count, "error") %> prohibited this booking from being saved:</h2>

      <ul>
      <% @booking.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :seats, "Select seat" %>
    <%= collection_select(:booking, :desk_id, Desk.all, :id, :name) %>
  </div>

  <div class="field">
    <%= f.label :start_at %>
    <%= f.datetime_select :start_at %>
  </div>
  <div class="field">
    <%= f.label :end_at %>
    <%= f.datetime_select :end_at %>
  </div>


  
  <div class="field">
    <%if current_user%>
      <%= f.hidden_field :user_id, :value => current_user.id %>
    <% end %>
  </div>

  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/bookings/edit.html.erb
<h1>Editing Booking</h1>

<%= render 'form' %>

<%= link_to 'Show', @booking %> |
<%= link_to 'Back', bookings_path %>

app/views/bookings/index.html.erb
<h1>Listing Bookings</h1>


<%= link_to 'Book New Seat', new_booking_path, class: "btn btn-primary" %>


<table class="table">
  <thead>
    <tr>
      <th>Name</th>
      <th>Desk</th>
      <th>From/To</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @bookings.each do |booking| %>
      <tr>
        <td><%= booking.user.name %></td>
        <td><%= booking.desk.name %></td>
        <td><%= booking.start_at.strftime("%d %b") %> - <%= booking.end_at.strftime("%d %b") %></td>
        <td><%#= booking.end_at %></td>

        <%if booking.end_at < DateTime.now %>
          <td>Past</td>
        <%else%>
          <%if current_user && booking.user == current_user%>
            <td><%= link_to 'View', booking %></td>
            <td><%= link_to 'Edit', edit_booking_path(booking) %></td>
            <td><%= link_to 'Cancel', booking, method: :delete, data: { confirm: 'Are you sure?' } %></td>
          <%else%>
            <td><%= link_to 'View', booking %></td>
          <% end -%>
        <% end -%>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

app/views/bookings/new.html.erb
<div class="container" style="margin-top: 50px;">
	<h1>New Booking</h1>

	<%= render 'form' %>

	<%= link_to 'Back', bookings_path %>
</div>

app/views/bookings/show.html.erb
<p id="notice"><%#= notice %></p>

<div class="container" style="margin-top: 50px;">
<p>
  <strong>Name:</strong>
  <%= @booking.user.name %>
</p>

<p>
  <strong>Email:</strong>
  <%= @booking.user.email %>
</p>

<p>
  <strong>Desk:</strong>
  <%= @booking.desk.name %>
</p>

<p>
  <strong>Date:</strong>
  <%= @booking.start_at.strftime("%d %b") %> - <%= @booking.end_at.strftime("%d %b") %>
</p>

<%= link_to 'Edit', edit_booking_path(@booking) %> |
<%= link_to 'Back', bookings_path %>
</div>

app/views/desks/_form.html.erb
<%= form_for(@desk) do |f| %>
  <% if @desk.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@desk.errors.count, "error") %> prohibited this desk from being saved:</h2>

      <ul>
      <% @desk.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/desks/edit.html.erb
<h1>Editing Desk</h1>

<%= render 'form' %>

<%= link_to 'Show', @desk %> |
<%= link_to 'Back', desks_path %>

app/views/desks/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Desks</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @desks.each do |desk| %>
      <tr>
        <td><%= desk.name %></td>
        <td><%= link_to 'Show', desk %></td>
        <td><%= link_to 'Edit', edit_desk_path(desk) %></td>
        <td><%= link_to 'Destroy', desk, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Desk', new_desk_path %>

app/views/desks/new.html.erb
<h1>New Desk</h1>

<%= render 'form' %>

<%= link_to 'Back', desks_path %>

app/views/desks/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @desk.name %>
</p>

<%= link_to 'Edit', edit_desk_path(@desk) %> |
<%= link_to 'Back', desks_path %>

app/views/layouts/_nav.html.erb
<nav class="navbar-text pull-right">
<% if user_signed_in? %>
  Logged in, Hi <strong><%= current_user.name %></strong>.
  <%= link_to 'Edit profile', edit_user_registration_path, :class => 'navbar-link' %> |
  <%= link_to "Logout", destroy_user_session_path, method: :delete, :class => 'navbar-link'  %>
<% else %>
  <%= link_to "Sign up", new_user_registration_path, :class => 'navbar-link'  %> |
  <%= link_to "Login", new_user_session_path, :class => 'navbar-link'  %>
<% end %>
</nav>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
<head>
  <title>Hotdesk</title>
  <%= stylesheet_link_tag    'application', media: 'all', 'data-turbolinks-track' => true %>
  <%= javascript_include_tag 'application', 'data-turbolinks-track' => true %>
  <%= csrf_meta_tags %>
</head>
<body>

<% if notice %>
  <p class="alert alert-success"><%= notice %></p>
<% end %>
<% if alert %>
  <p class="alert alert-danger"><%= alert %></p>
<% end %>


<%= render "layouts/nav" %>

<div class="container">
  <%= yield %>
</div>

</body>
</html>

app/views/users/_form.html.erb
<%= form_for(@user) do |f| %>
  <% if @user.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@user.errors.count, "error") %> prohibited this user from being saved:</h2>

      <ul>
      <% @user.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/users/edit.html.erb
<h1>Editing User</h1>

<%= render 'form' %>

<%= link_to 'Show', @user %> |
<%= link_to 'Back', users_path %>

app/views/users/index.html.erb
<p id="notice"><%= notice %></p>

<h1>Listing Users</h1>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @users.each do |user| %>
      <tr>
        <td><%= user.name %></td>
        <td><%= link_to 'Show', user %></td>
        <td><%= link_to 'Edit', edit_user_path(user) %></td>
        <td><%= link_to 'Destroy', user, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New User', new_user_path %>

app/views/users/new.html.erb
<h1>New User</h1>

<%= render 'form' %>

<%= link_to 'Back', users_path %>

app/views/users/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @user.name %>
</p>

<%= link_to 'Edit', edit_user_path(@user) %> |
<%= link_to 'Back', users_path %>